<template>
  <div class="dashboard-content">

    <div class="container">
      <div class="flex-parent">
        <div class="card" v-html="measurementDescription">
        </div>
      </div>
    </div>

    <div class="flex-item-select spacing">
      <cdx-toggle-button-group v-model="chartValue" :buttons="buttons" />
    </div>
    <div class="flex-parent-select">
      <div class="flex-item-select">
        <cdx-select v-model:selected="appStateStore.currentYear" :menu-items="appStateStore.years"
          default-label="Select a year" :default-icon="cdxIconMapPin" />
      </div>
      <div v-show="isWorldMap || isTreeMap" class="flex-item-select">
        <cdx-select v-model:selected="selectedMeasurement" :menu-items="measurementsMenu"
          default-label="Select a measurement" :default-icon="cdxIconMapPin" />
      </div>

      <div v-show="isBarchart" class="flex-item-select">
        <cdx-select v-model:selected="appStateStore.currentGeographyLevel" :menu-items="geographyLevels"
          default-label="Select a Geo-filter" :default-icon="cdxIconMapPin" />
      </div>
    </div>

    <div class="flex-item-select" v-if="isMultiSelectGroupDataComplete && (isWorldMap || isTextualTable)">
      <multi-select-group-checkbox :menu-data="multiSelectMenuItems" :max-selections="maxSelections"
        :model-value="appStateStore.multiSelectModelValue" @update:modelValue="updateMultiSelectModel">

      </multi-select-group-checkbox>
    </div>

    <div v-show="isWorldMap">
      <div class="container">
        <div class="flex-parent">
          <div class="flex-item cards">
            <CardChart :cards="cardData" />
          </div>
          <div class="flex-item world-map">
            <WorldMap v-if="dataLoadedWorldMap && isMultiSelectGroupDataComplete" title="World Map"
              :metric="selectedMeasurement" :worldMapData="worldMapData" :countryData="countryData"
              :filterData="appStateStore.multiSelectModelValue" />
          </div>
        </div>
      </div>

    </div>

    <div v-show="isBarchart">

      <div class="flex-item-select" v-show="appStateStore.currentGeographyLevel !== null">
        <multi-select-checkbox :menuItems="geographyAreaList" :modelValue="selectedGeos" :minSelections="0"
          :maxSelections="9" :buttonText="'Geographies selected'" @update:modelValue="updateSelectedGeos" />
      </div>
      <div class="spacing">
        <Barchart v-if="dataLoadedBarChart" title="Bar Chart" :measurementType="measurementType"
          :orientation="chartOrientation" :seriesResults="barChartData" />
      </div>
    </div>

    <div v-show="isTreeMap">
      <TreeMap v-if="dataLoadedTreeMap && isMultiSelectGroupDataComplete" title="Treemap Chart" root="Equity Landscape" :measurement="selectedMeasurement"
        :treeMapData="treeMapData" />
    </div>
    <div v-show="isTextualTable">

      <div class="spacing-textual" v-if="dataLoadedTextualTable">
        <TextTable title="Textual Table" :data="textualTableData" :measurements="measurements"
          :excludeColumns="excludeColumns" :filterData="appStateStore.multiSelectModelValue" />
      </div>
    </div>

    <div v-show="!isChartTypeLoaded">
      <Message v-if="noDataFound" :message="noDataMessage" type="warning" class="spacing" />
      <Message v-else-if="!appStateStore.currentGeographyLevel && chartType() !== 'WorldMap'"
        :message="selectGeoFilterMessage" type="notice" class="spacing" />
      <Message v-else-if="chartType() === 'WorldMap'" :message="noDataMessage" type="warning" class="spacing" />
      <cdx-progress-bar v-else />
    </div>
  </div>
</template>



<script setup lang="ts">
import { ref, computed,  watchEffect,  onBeforeMount } from 'vue';
import { useDataStore, type MenuItem } from '@/stores/data';
import { useChartStore, ChartType as ChartValue } from '@/stores/chart';
import { useAppStateStore } from '@/stores/appState';


import CardChart from './CardChart.vue';
import WorldMap from '@/components/WorldMap.vue';
import Barchart from '@/components/Barchart.vue';
import TreeMap from '@/components/TreeMap.vue';
import TextTable from '@/components/TextTable.vue';
import { CdxSelect, CdxToggleButtonGroup, CdxProgressBar } from '@wikimedia/codex';
import { cdxIconMapPin } from '@wikimedia/codex-icons';
import { } from '@wikimedia/codex-design-tokens/theme-wikimedia-ui.less'

import Message from '@/components/Message.vue';
import type { ButtonGroupItem } from '@wikimedia/codex';
import MultiSelectCheckbox from '@/components/MultiSelectCheckbox.vue';
import MultiSelectGroupCheckbox from '@/components/MultiSelectGroupCheckbox.vue';

// Stores
const appStateStore = useAppStateStore();
const dataStore = useDataStore();
const chartStore = useChartStore();


const props = defineProps<{
  measurementType: number;
}>();


// General chart variables
const chartValue = ref(ChartValue.WORLDMAP);
const selectGeoFilterMessage = 'Select a geo filter';
const noDataMessage = 'No data available';
const noDataFound = ref(false);
const measurementType = ref(props.measurementType);
const storeMeasurements = dataStore.getObervations(measurementType.value);
const measurementsMenu = ref(chartStore.getObservationMenuItems(measurementType.value));
const selectedMeasurement = ref(storeMeasurements[0]);
const measurementDescription = ref(dataStore.getObservationCardDescription(measurementType.value));

const geographyLevels = ref(appStateStore.geographyLevels);
const geographyAreaList = ref(chartStore.getStateVariable('geoList', []));

// Barchart variables
const chartOrientation = ref('x');
const barChartData: any = ref([]);
const dataLoadedBarChart = ref(false);
const selectedGeos: any = ref([]);

//TreeMap variables

const treeMapData: any = ref([]);
const dataLoadedTreeMap = ref(false);


// TextualTable variables
const textualTableData: any = ref([]);
const dataLoadedTextualTable = ref(false);

const measurements = ref(storeMeasurements);
const excludeColumns = ref(['country_name']);

// Card variables
const cardData = ref([]);
const dataLoadedCard = ref(false);

// WorldMap variables
const worldMapData: any = ref([]);
const countryData: any = ref([]);
const dataLoadedWorldMap = ref(false);



const multiSelectMenuItems: any = ref([]);
const maxSelections = ref(9);

const isDataFetchComplete = ref(false);


// Toggle buttons
const buttons: ButtonGroupItem[] = [
  {
    label: 'World Map',
    value: ChartValue.WORLDMAP,
  },
  {
    label: 'Barchart (Vertical)',
    value: ChartValue.BARCHARTX,
  },
  {
    label: 'Barchart (Horizontal)',
    value: ChartValue.BARCHARTY,
  },
  {
    label: 'Tree Map',
    value: ChartValue.TREEMAP,
  },
  {
    label: 'Text Table',
    value: ChartValue.TEXTUALTABLE,
  },
];

const chartType = () => {
  if (chartValue.value === ChartValue.WORLDMAP) {
    return 'WorldMap';
  } else if (chartValue.value === ChartValue.BARCHARTX || chartValue.value === ChartValue.BARCHARTY) {
    chartOrientation.value = chartValue.value === ChartValue.BARCHARTX ? 'x' : 'y';
    return 'Barchart';
  } else if (chartValue.value === ChartValue.TREEMAP) {
    return 'TreeMap';
  }
  else if (chartValue.value === ChartValue.TEXTUALTABLE) {
    return 'TextTable';
  }
}

const isChartTypeLoaded = computed(() => {
  switch (chartType()) {
    case 'WorldMap':
      return dataLoadedWorldMap.value && dataLoadedCard.value;
    case 'Barchart':
      return appStateStore.currentGeographyLevel !== null && dataLoadedBarChart.value;
    case 'TreeMap':
      return dataLoadedTreeMap.value;
    case 'TextTable':
      return appStateStore.currentGeographyLevel !== null
  }
});

const setDataLoadingState = (data: any, dataLoaded: any, noDataFound: any) => {
  if (chartStore.isEmpty(data)) {
    dataLoaded.value = false;
    noDataFound.value = true;
  } else {
    dataLoaded.value = true;
    noDataFound.value = false;
  }
};

const loadSeriesObjects = () => {
  const geographyLevel = appStateStore.currentGeographyLevel;
  chartStore.setGeoList(geographyLevel);
  geographyAreaList.value = chartStore.getStateVariable('geoList', []);
  // Filter out Antarctica
  geographyAreaList.value = geographyAreaList.value.filter((geo: any) => geo.label !== 'Antarctica');
  const geoList = [... new Set<string>(selectedGeos.value)];


  chartStore.createSeriesObjects(measurementType.value, geoList);
}

const isWorldMap = computed(() => chartType() === 'WorldMap');
const isBarchart = computed(() => chartType() === 'Barchart');
const isTreeMap = computed(() => chartType() === 'TreeMap');
const isTextualTable = computed(() => chartType() === 'TextTable');
const isMultiSelectGroupDataComplete = computed(() => {
  loadMultiSelectGroupData();
  return maxSelections.value > 0;
});


const load = async () => {
  const chart = chartType();

  if (chart === 'TreeMap') {
    chartStore.createTreeMapObjects(measurementType.value, selectedMeasurement.value);
    treeMapData.value = chartStore.getStateVariable('treeMapResults', []);
    setDataLoadingState(treeMapData.value, dataLoadedTreeMap, noDataFound);
  } else if (chart === 'Barchart' && appStateStore.currentGeographyLevel !== null) {
    loadSeriesObjects();
    barChartData.value = chartStore.getStateVariable('seriesResults', []);
    setDataLoadingState(barChartData.value, dataLoadedBarChart, noDataFound);
  } else if (chart === 'TextTable' && appStateStore.currentGeographyLevel !== null) {
    textualTableData.value = dataStore.getFilteredGeos('country', measurementType.value);
    setDataLoadingState(textualTableData.value, dataLoadedTextualTable, noDataFound);
  }
  else if (chart === 'WorldMap') {
    chartStore.createCardObjects(measurementType.value);
    cardData.value = chartStore.getStateVariable('cardResults', []);
    setDataLoadingState(cardData.value, dataLoadedCard, noDataFound);

    worldMapData.value = dataStore.getStateVariable('worldData', []);
    countryData.value = dataStore.getFilteredGeos('country', measurementType.value);
    setDataLoadingState(countryData.value, dataLoadedWorldMap, noDataFound);
    if (dataLoadedWorldMap.value) {
      setDataLoadingState(multiSelectMenuItems.value, dataLoadedWorldMap, noDataFound);
    }
  }


};

const loadMultiSelectGroupData = (() => {
  const inputData = dataStore.getCountryData();

  const continents = getGeographicalData(inputData, 'continent_name');

  const subcontinents = getGeographicalData(inputData, 'subcontinent_name');

  const countries = getGeographicalData(inputData, 'country_name');

  // remove Antarctica


  multiSelectMenuItems.value = [
    {
      groupLabel: 'Continents',
      items: continents
    },
    {
      groupLabel: 'Subcontinents',
      items: subcontinents
    },
    {
      groupLabel: 'Countries',
      items: countries
    }
  ] as MenuItem[];

  maxSelections.value = continents.length + subcontinents.length + countries.length;

});



const getGeographicalData = (data: any, label: string) => {
  let geoData = [...new Set(data.map((item: any) => item[label]))].map(item => ({ value: item, label: item }));

  if (geoData.length > 0) {
    geoData = geoData.filter((geo: any) => geo.label !== 'Antarctica');

    // sort alphabetically
    geoData.sort((a: any, b: any) => {
      if (a.label < b.label) {
        return -1;
      }
      if (a.label > b.label) {
        return 1;
      }
      return 0;
    });
  }


  return geoData
};


const updateSelectedGeos = (updatedGeos: string[]) => {
  selectedGeos.value = updatedGeos;
}

const updateMultiSelectModel = (updatedGeos: string[]) => {
  appStateStore.multiSelectModelValue = updatedGeos;
}

const loadAllData = async () => {
  if (!isDataFetchComplete.value) {
    dataStore.fetchAllData().then(() => {
    });

    isDataFetchComplete.value = true;
  }
  load();
}

watchEffect(async () => {
  await loadAllData();
});


onBeforeMount(async () => {
  await loadAllData();
});


</script>

<style lang="less">
@import (reference) '@wikimedia/codex-design-tokens/theme-wikimedia-ui.less';
</style>
<style scoped lang="scss">
@import "@/scss/dashboard.scss";
</style>
<style scoped lang="css">
@import "@wikimedia/codex/dist/codex.style.css";
</style>

